/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	rawdevicev1 "github.com/alauda/nativestor/apis/rawdevice/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeRawDevices implements RawDeviceInterface
type FakeRawDevices struct {
	Fake *FakeRawdeviceV1
}

var rawdevicesResource = schema.GroupVersionResource{Group: "nativestor.alauda.io", Version: "v1", Resource: "rawdevices"}

var rawdevicesKind = schema.GroupVersionKind{Group: "nativestor.alauda.io", Version: "v1", Kind: "RawDevice"}

// Get takes name of the rawDevice, and returns the corresponding rawDevice object, and an error if there is any.
func (c *FakeRawDevices) Get(ctx context.Context, name string, options v1.GetOptions) (result *rawdevicev1.RawDevice, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(rawdevicesResource, name), &rawdevicev1.RawDevice{})
	if obj == nil {
		return nil, err
	}
	return obj.(*rawdevicev1.RawDevice), err
}

// List takes label and field selectors, and returns the list of RawDevices that match those selectors.
func (c *FakeRawDevices) List(ctx context.Context, opts v1.ListOptions) (result *rawdevicev1.RawDeviceList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(rawdevicesResource, rawdevicesKind, opts), &rawdevicev1.RawDeviceList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &rawdevicev1.RawDeviceList{ListMeta: obj.(*rawdevicev1.RawDeviceList).ListMeta}
	for _, item := range obj.(*rawdevicev1.RawDeviceList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested rawDevices.
func (c *FakeRawDevices) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(rawdevicesResource, opts))
}

// Create takes the representation of a rawDevice and creates it.  Returns the server's representation of the rawDevice, and an error, if there is any.
func (c *FakeRawDevices) Create(ctx context.Context, rawDevice *rawdevicev1.RawDevice, opts v1.CreateOptions) (result *rawdevicev1.RawDevice, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(rawdevicesResource, rawDevice), &rawdevicev1.RawDevice{})
	if obj == nil {
		return nil, err
	}
	return obj.(*rawdevicev1.RawDevice), err
}

// Update takes the representation of a rawDevice and updates it. Returns the server's representation of the rawDevice, and an error, if there is any.
func (c *FakeRawDevices) Update(ctx context.Context, rawDevice *rawdevicev1.RawDevice, opts v1.UpdateOptions) (result *rawdevicev1.RawDevice, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(rawdevicesResource, rawDevice), &rawdevicev1.RawDevice{})
	if obj == nil {
		return nil, err
	}
	return obj.(*rawdevicev1.RawDevice), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeRawDevices) UpdateStatus(ctx context.Context, rawDevice *rawdevicev1.RawDevice, opts v1.UpdateOptions) (*rawdevicev1.RawDevice, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(rawdevicesResource, "status", rawDevice), &rawdevicev1.RawDevice{})
	if obj == nil {
		return nil, err
	}
	return obj.(*rawdevicev1.RawDevice), err
}

// Delete takes name of the rawDevice and deletes it. Returns an error if one occurs.
func (c *FakeRawDevices) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(rawdevicesResource, name), &rawdevicev1.RawDevice{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeRawDevices) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(rawdevicesResource, listOpts)

	_, err := c.Fake.Invokes(action, &rawdevicev1.RawDeviceList{})
	return err
}

// Patch applies the patch and returns the patched rawDevice.
func (c *FakeRawDevices) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *rawdevicev1.RawDevice, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(rawdevicesResource, name, pt, data, subresources...), &rawdevicev1.RawDevice{})
	if obj == nil {
		return nil, err
	}
	return obj.(*rawdevicev1.RawDevice), err
}
