/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	rawdevicev1 "github.com/alauda/nativestor/apis/rawdevice/v1"
	versioned "github.com/alauda/nativestor/generated/nativestore/rawdevice/clientset/versioned"
	internalinterfaces "github.com/alauda/nativestor/generated/nativestore/rawdevice/informers/externalversions/internalinterfaces"
	v1 "github.com/alauda/nativestor/generated/nativestore/rawdevice/listers/rawdevice/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// RawDeviceInformer provides access to a shared informer and lister for
// RawDevices.
type RawDeviceInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.RawDeviceLister
}

type rawDeviceInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewRawDeviceInformer constructs a new informer for RawDevice type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewRawDeviceInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredRawDeviceInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredRawDeviceInformer constructs a new informer for RawDevice type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredRawDeviceInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.RawdeviceV1().RawDevices().List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.RawdeviceV1().RawDevices().Watch(context.TODO(), options)
			},
		},
		&rawdevicev1.RawDevice{},
		resyncPeriod,
		indexers,
	)
}

func (f *rawDeviceInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredRawDeviceInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *rawDeviceInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&rawdevicev1.RawDevice{}, f.defaultInformer)
}

func (f *rawDeviceInformer) Lister() v1.RawDeviceLister {
	return v1.NewRawDeviceLister(f.Informer().GetIndexer())
}
