/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/alauda/nativestor/apis/rawdevice/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// RawDeviceLister helps list RawDevices.
// All objects returned here must be treated as read-only.
type RawDeviceLister interface {
	// List lists all RawDevices in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1.RawDevice, err error)
	// Get retrieves the RawDevice from the index for a given name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1.RawDevice, error)
	RawDeviceListerExpansion
}

// rawDeviceLister implements the RawDeviceLister interface.
type rawDeviceLister struct {
	indexer cache.Indexer
}

// NewRawDeviceLister returns a new RawDeviceLister.
func NewRawDeviceLister(indexer cache.Indexer) RawDeviceLister {
	return &rawDeviceLister{indexer: indexer}
}

// List lists all RawDevices in the indexer.
func (s *rawDeviceLister) List(selector labels.Selector) (ret []*v1.RawDevice, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.RawDevice))
	})
	return ret, err
}

// Get retrieves the RawDevice from the index for a given name.
func (s *rawDeviceLister) Get(name string) (*v1.RawDevice, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("rawdevice"), name)
	}
	return obj.(*v1.RawDevice), nil
}
