/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package v2

import (
	"context"
	"time"

	v2 "github.com/alauda/nativestor/apis/topolvm/v2"
	scheme "github.com/alauda/nativestor/generated/nativestore/topolvm/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// TopolvmClustersGetter has a method to return a TopolvmClusterInterface.
// A group's client should implement this interface.
type TopolvmClustersGetter interface {
	TopolvmClusters(namespace string) TopolvmClusterInterface
}

// TopolvmClusterInterface has methods to work with TopolvmCluster resources.
type TopolvmClusterInterface interface {
	Create(ctx context.Context, topolvmCluster *v2.TopolvmCluster, opts v1.CreateOptions) (*v2.TopolvmCluster, error)
	Update(ctx context.Context, topolvmCluster *v2.TopolvmCluster, opts v1.UpdateOptions) (*v2.TopolvmCluster, error)
	UpdateStatus(ctx context.Context, topolvmCluster *v2.TopolvmCluster, opts v1.UpdateOptions) (*v2.TopolvmCluster, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v2.TopolvmCluster, error)
	List(ctx context.Context, opts v1.ListOptions) (*v2.TopolvmClusterList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v2.TopolvmCluster, err error)
	TopolvmClusterExpansion
}

// topolvmClusters implements TopolvmClusterInterface
type topolvmClusters struct {
	client rest.Interface
	ns     string
}

// newTopolvmClusters returns a TopolvmClusters
func newTopolvmClusters(c *TopolvmV2Client, namespace string) *topolvmClusters {
	return &topolvmClusters{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the topolvmCluster, and returns the corresponding topolvmCluster object, and an error if there is any.
func (c *topolvmClusters) Get(ctx context.Context, name string, options v1.GetOptions) (result *v2.TopolvmCluster, err error) {
	result = &v2.TopolvmCluster{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("topolvmclusters").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of TopolvmClusters that match those selectors.
func (c *topolvmClusters) List(ctx context.Context, opts v1.ListOptions) (result *v2.TopolvmClusterList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v2.TopolvmClusterList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("topolvmclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested topolvmClusters.
func (c *topolvmClusters) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("topolvmclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a topolvmCluster and creates it.  Returns the server's representation of the topolvmCluster, and an error, if there is any.
func (c *topolvmClusters) Create(ctx context.Context, topolvmCluster *v2.TopolvmCluster, opts v1.CreateOptions) (result *v2.TopolvmCluster, err error) {
	result = &v2.TopolvmCluster{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("topolvmclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(topolvmCluster).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a topolvmCluster and updates it. Returns the server's representation of the topolvmCluster, and an error, if there is any.
func (c *topolvmClusters) Update(ctx context.Context, topolvmCluster *v2.TopolvmCluster, opts v1.UpdateOptions) (result *v2.TopolvmCluster, err error) {
	result = &v2.TopolvmCluster{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("topolvmclusters").
		Name(topolvmCluster.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(topolvmCluster).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *topolvmClusters) UpdateStatus(ctx context.Context, topolvmCluster *v2.TopolvmCluster, opts v1.UpdateOptions) (result *v2.TopolvmCluster, err error) {
	result = &v2.TopolvmCluster{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("topolvmclusters").
		Name(topolvmCluster.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(topolvmCluster).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the topolvmCluster and deletes it. Returns an error if one occurs.
func (c *topolvmClusters) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("topolvmclusters").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *topolvmClusters) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("topolvmclusters").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched topolvmCluster.
func (c *topolvmClusters) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v2.TopolvmCluster, err error) {
	result = &v2.TopolvmCluster{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("topolvmclusters").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
